//Dslr Notifier
var _poller = false;
var _statusint = 500;
var _factor = 60000;
var dslrPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("reportstatus.");
window.addEventListener('load', onInit(), false);

var PollStatusTimer = {
	_timer: null,
	
	init: function(aDelay){
		this.cancel();
		this._timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		this._timer.init(this, aDelay, this._timer.TYPE_REPEATING_PRECISE);
	},

	cancel: function(){
		if(this._timer){
			this._timer.cancel();
			this._timer = null;
		}
	},

	observe: function(aSubject, aTopic, aData){

		try {		
			
			// check to make sure *someone* is polling the server..
			var firstFlag = dslrPref.getBoolPref("firstFlag");
			if ((typeof firstFlag != "undefined") &&  firstFlag) {
				
				dslrPref.setBoolPref("firstFlag", false);
				_poller = true;
				
				var ival = dslrPref.getIntPref("pollIntMinutes", 1);
				if (ival != -1) { PollServerTimer.init(ival*_factor); }
				
			}
			
			// Respond to preference changes
			if (_poller && 	dslrPref.getBoolPref("prefsChange")) {
				
				dslrPref.setBoolPref("prefsChange", false);
				PollServerTimer.cancel();
				
				var ival = dslrPref.getIntPref("pollIntMinutes", 1);
				if (ival != -1) { 
					PollServerTimer.init(ival*_factor);  }
				else { 
					// turn down the flags
					dslrPref.setBoolPref("imFlag", false);
					dslrPref.setBoolPref("newsFlag", false);
		
				}
					
			}
			
			var imFlag = dslrPref.getBoolPref("imFlag");
			var popPref = dslrPref.getBoolPref("poppref");
			var popOnce = dslrPref.getBoolPref("poponce");

			if (imFlag == true) { 
					if (popPref == true && popOnce == false) { 
						dslrPref.setBoolPref("poponce", true); 
						alert("You have "+dslrPref.getCharPref("imText")+".");
						}
				}
			var pollImFlag = dslrPref.getBoolPref("pollIm");
				if ((typeof imFlag != "undefined") && (pollImFlag = true)) {
						document.getElementById('imbar').setAttribute('hidden', !imFlag);
						document.getElementById('impix').setAttribute('tooltiptext', dslrPref.getCharPref("imText")); 
				} 
			else { dslrPref.setBoolPref("imFlag", false); }
	
			var nFlag = dslrPref.getBoolPref("newsFlag");
			var pollTopFlag = dslrPref.getBoolPref("pollTop");
				if ((typeof nFlag != "undefined") && (pollTopFlag = true)) {
			
					// show the news flag
					document.getElementById('newsbar').setAttribute('hidden', !nFlag);
					document.getElementById('newspix').setAttribute('tooltiptext', dslrPref.getCharPref("newsText")); 
				}
					
			else {	dslrPref.setBoolPref("newsFlag", false); }
			
			var logFlag = dslrPref.getBoolPref("loginFlag");
			if (logFlag == true) {
				document.getElementById('dslr-menu').setAttribute('hidden', 'true'); }
			else { document.getElementById('dslr-menu').setAttribute('hidden', 'false'); }
			if (typeof logFlag != "undefined") {
			
				// show the login flag
					document.getElementById('loginbar').setAttribute('hidden', !logFlag);
					document.getElementById('loginpix').setAttribute('tooltiptext', "Log in to "+dslrPref.getCharPref("siteName", "Broadbandreports.com")+"!"); }
			else { dslrPref.setBoolPref("loginFlag", false); }
		}
		catch (q) {  }
	}
} 
var PollServerTimer = {
	_timer: null,
	
	init: function(aDelay){
		
		this.cancel();
		this._timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		this._timer.init(this, aDelay, this._timer.TYPE_REPEATING_SLACK);
	},

	cancel: function(){
		if(this._timer){
			this._timer.cancel();
			this._timer = null;
		}
	},
	observe: function(aSubject, aTopic, aData){
	dslrPollIt();	
	}
}

function dslrPollIt() {
	try { 
			var dslrPIt = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("reportstatus.");
			// http://www.Broadbandreports.com/browser/extensions/reportstatus.xml
			var pollUrl = "http://www."+dslrPIt.getCharPref("siteName", "Broadbandreports.com")+"/browser/extensions/reportstatus.xml?ver=0.8";
			
			var oldstatus = window.status;
			window.status = "notifier: polling";
			
			// Fetch XML data
			var rf = new XMLHttpRequest();
	
			rf.open("GET", pollUrl, true);
			rf.overrideMimeType("text/xml");
						
			function loaded () {
			
				try { 
					
					if (rf.readyState != 4) { return; }
				
					window.status = oldstatus;
					
					if (window.status.substr(0,9) == "notifier:") { window.status = ""; }
						
					var doc = rf.responseXML;
					var element = doc.documentElement;
					
					if (element.tagName != "m") {
						
						// we're not logged in...turn on the login flag
						dslrPIt.setBoolPref("loginFlag", true);
						dslrPIt.setBoolPref("imFlag", false);
						dslrPIt.setBoolPref("newsFlag", false);
						dslrPIt.setIntPref("pollIntMinutes", 1);
						dslrPIt.setBoolPref("prefsChange", true);
						
						return;
						
					}
					else {
						
						// we are logged in. hide the login button
						dslrPIt.setBoolPref("loginFlag", false);
					}
		
					var aStr = element.getAttribute("i");
					var nStr = element.getAttribute("n");
							
					var checkIM = dslrPIt.getBoolPref("pollIm");
					if (aStr != null) {
						
							dslrPIt.setBoolPref("imFlag", true);
							dslrPIt.setCharPref("imText", aStr);
						}
					else {
						
						dslrPIt.setBoolPref("imFlag", false);
						dslrPIt.setCharPref("imText", "");	
					}
					if (checkIM != true) {
						dslrPIt.setBoolPref("imFlag", false); }
					
					var checkTop = dslrPIt.getBoolPref("pollTop");
					if (nStr != null) {
					
							dslrPIt.setBoolPref("newsFlag", true);
							dslrPIt.setCharPref("newsText", nStr);
					}
					else {
						dslrPIt.setBoolPref("newsFlag", false);
						dslrPIt.setCharPref("newsText", "");			
					}
					if (checkTop != true) {
						dslrPIt.setBoolPref("newsFlag", false); }
				}
				catch(f) {
				//Server timeout
				}
					
			}
			
			rf.onreadystatechange = loaded;
			rf.send(null);

		}
		catch(e) {
		//Polling error
		}
	}

function onffStart() {
		var dslrffS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("reportstatus.");
		var firstPoll = dslrffS.getIntPref("pollFlag");
		if (firstPoll == 0) {
		dslrffS.setBoolPref("serverOk", true);
		dslrffS.setIntPref("pollFlag", 1);
		dslrPollIt();
		}
}

function onInit() {
var appcontent = document.getElementById("appcontent");
if(appcontent)
appcontent.addEventListener("load", onffStart(), true);
} 

var Manager = {
	_manager: null,

	stop: function() {

		if (_poller) { dslrPref.setBoolPref("firstFlag", true); }

		// Is this the last closing window?
		try{
			var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
			var browsers=wm.getZOrderDOMWindowEnumerator('navigator:browser',true);
			if(browsers.hasMoreElements()) { var browser=browsers.getNext(); }
			if(browsers.hasMoreElements()) { return; }
		}
		catch(e){ return; }
		// If it's the last one, reset all temp values
		dslrPref.setBoolPref("firstFlag", true);
		dslrPref.setBoolPref("imFlag", false); 
		dslrPref.setBoolPref("newsFlag", false); 
		dslrPref.setCharPref("imText", ""); 
		dslrPref.setCharPref("newsText", "");
		dslrPref.setIntPref("pollFlag", 0);
		dslrPref.setBoolPref("poponce", false);
							
	}
	
}

window.addEventListener("close", Manager.stop, false);
PollStatusTimer.init(_statusint);