// package constants
const DISPLAY_NAME   = "DSLR Notifier";
const NAME           = "reportstatus";
const KEY            = "/RyanF/reportstatus";
const VERSION        = "0.8";
const LOCALE_LIST    = ["en-US"];
const JAR_FILE       = NAME + ".jar";
const PREFS_FILE     = "defaults/preferences/" + NAME + ".js";
const AUTOREG_FILE   = "defaults/.autoreg";


const CONTENT_FOLDER = "content/" + NAME + "/";

var err = null;

// begin the install
initInstall(NAME, KEY, VERSION);
  
var mainDir = getFolder("Profile", "extensions/" + "{9dfaef2c-b772-4bde-b5fc-1f69bd105c16}");
var chromeDir = getFolder(mainDir, "chrome");

addFile(KEY, VERSION, "chrome/"+JAR_FILE, chromeDir, null);

// Add the defaults folder
var defaultDir = getFolder(mainDir, "defaults");
addDirectory(KEY, VERSION, "defaults", defaultDir, null);
defaultDir = getFolder(getFolder("Program", "defaults"),"pref");
addFile(KEY, VERSION, PREFS_FILE, defaultDir, null);

//hack to make sure we register the component
var pgmDir = getFolder("Program");
addFile(KEY, VERSION, AUTOREG_FILE, pgmDir, null);
 
// Register the chrome URLs
registerChrome(Install.CONTENT | PROFILE_CHROME, getFolder(chromeDir, JAR_FILE), "content/"+NAME+"/");
//registerChrome(Install.SKIN | PROFILE_CHROME, getFolder(chromeDir, JAR_FILE), "skin/classic/"+NAME+"/");

for (var x = 0; x < LOCALE_LIST.length; x++)
  registerChrome(Install.LOCALE | PROFILE_CHROME, getFolder(chromeDir, JAR_FILE), "locale/"+LOCALE_LIST[x]+"/"+NAME+"/");

/*var compDir = getFolder("Components");
for (x = 0; x < XPCOM_NAMES_JS.length; x++)
  addFile(KEY, VERSION, XPCOM_DIREC+XPCOM_NAMES_JS[x]+".js", compDir, null);
for (x = 0; x < XPCOM_NAMES_XPT.length; x++)
  addFile(KEY, VERSION, XPCOM_DIREC+XPCOM_NAMES_XPT[x]+".xpt", compDir, null);*/


// Now install..
if (getLastError() == SUCCESS) {
  err = performInstall();
  if ((err == SUCCESS) || (err == 999))
    alert(DISPLAY_NAME + " " + VERSION + " has been installed successfully!\nPlease restart to enable the extension.");
}
else
  cancelInstall();